# You can use the following code to check your solvers
# the following puzzle is solvable immediately with the LP relaxation
puzzle = [[8, 5, 0, 0, 0, 2, 4, 0, 0], 
          [7, 2, 0, 0, 0, 0, 0, 0, 9], 
          [0, 0, 4, 0, 0, 0, 0, 0, 0], 
          [0, 0, 0, 1, 0, 7, 0, 0, 2], 
          [3, 0, 5, 0, 0, 0, 9, 0, 0], 
          [0, 4, 0, 0, 0, 0, 0, 0, 0], 
          [0, 0, 0, 0, 8, 0, 0, 7, 0], 
          [0, 1, 7, 0, 0, 0, 0, 0, 0], 
          [0, 0, 0, 0, 3, 6, 0, 4, 0]]

# so calling sudoku.solve_puzzle(puzzle) should return
([[8, 5, 9, 6, 1, 2, 4, 3, 7], 
  [7, 2, 3, 8, 5, 4, 1, 6, 9], 
  [1, 6, 4, 3, 7, 9, 5, 2, 8], 
  [9, 8, 6, 1, 4, 7, 3, 5, 2], 
  [3, 7, 5, 2, 6, 8, 9, 1, 4], 
  [2, 4, 1, 5, 9, 3, 7, 8, 6], 
  [4, 3, 2, 9, 8, 1, 6, 7, 5], 
  [6, 1, 7, 4, 2, 5, 8, 9, 3], 
  [5, 9, 8, 7, 3, 6, 2, 4, 1]],
 [])


# The following puzzle requires additional branch and bound steps
puzzle = [[4, 8, 0, 3, 0, 0, 0, 0, 0], 
          [0, 0, 0, 0, 0, 0, 0, 7, 1], 
          [0, 2, 0, 0, 0, 0, 0, 0, 0], 
          [7, 0, 5, 0, 0, 0, 0, 6, 0], 
          [0, 0, 0, 2, 0, 0, 8, 0, 0], 
          [0, 0, 0, 0, 0, 0, 0, 0, 0], 
          [0, 0, 1, 0, 7, 6, 0, 0, 0], 
          [3, 0, 0, 0, 0, 0, 4, 0, 0], 
          [0, 0, 0, 0, 5, 0, 0, 0, 0]]

# calling sudoku.solve_puzzle(puzzle) could return
([[4, 8, 7, 3, 1, 2, 6, 9, 5], 
  [5, 9, 3, 6, 8, 4, 2, 7, 1], 
  [1, 2, 6, 5, 9, 7, 3, 8, 4], 
  [7, 3, 5, 8, 4, 9, 1, 6, 2], 
  [9, 1, 4, 2, 6, 5, 8, 3, 7], 
  [2, 6, 8, 7, 3, 1, 5, 4, 9], 
  [8, 5, 1, 4, 7, 6, 9, 2, 3], 
  [3, 7, 9, 1, 2, 8, 4, 5, 6], 
  [6, 4, 2, 9, 5, 3, 7, 1, 8]],
 [(8, 5, 2, 1), (5, 3, 4, 1)])

# your solution need not return these exact same constraints
# (depending on numerical precision issues, you might split on
# different z variables), but it _should_ be the case that your solver
# returns this same puzzle solution, and that your optimization solver
# returns this solution when given these constraints
